	INCLUDE EFR32MG12.inc			; CPU register definitions	
	INCLUDE	defines.inc
		
	AREA    |.text|, CODE, READONLY	; another section in the CODE area	
;-------------------------------------------------------------------------------
GPIO_setup	PROC				; I/O Ports configuration
	EXPORT	GPIO_setup
	OORW	1<<3, CMU_HFBUSCLKEN0, CMU	; enable clock to GPIO
	OORW	(0x11<<24), GPIO_PD_MODEH, GPIO	; configure PD14&15 for digital input
	OORW	0x44, GPIO_PD_MODEH		; congigure PD8,9 for RG LED	
	PUTW	(0x33<<24), GPIO_EXTIPSELH	; select PORTD for interrupt 14, 15
	PUTW	0x32<<24, GPIO_EXTIPINSELH	; select pin 14, 15 for interrupt
	PUTW	BUTTON0+BUTTON1, GPIO_EXTIFALL	; select falling edge for interrupt 14, 15
	PUTW	BUTTON0+BUTTON1, GPIO_IEN	; enable interupt 14, 15
	OORW	1<<10, 0, NVIC_ISER0		; enable even port pins interrupt in NVIC
	OORW	1<<18, 0, NVIC_ISER0		; enable odd  port pins interrupt in NVIC
	bx	LR
	ENDP	

;-------------------------------------------------------------------------------
LETIMER_setup	PROC
	EXPORT	LETIMER_setup
	PUTW	1, CMU_LFACLKEN0, CMU		; enable LFA clock for LETIMER	
	PUTW	1<<9, LETIMERn_CTRL, LETIMER0	; set period	
	PUTW	2, LETIMERn_CMD			; make sure tat timer is not running
	PUTW	600, LETIMERn_COMP0		; ~20 ms period
	PUTW	0x1F, LETIMERn_IFC		; clear all IF	
	PUTW	4, LETIMERn_IEN			; enable UF interrupt
	OORW	1<<27, 0, NVIC_ISER0		; enable timer interrupt in NVIC
	bx	LR
	ENDP
		
	ALIGN
	END
	